#include "distances.h"
#include "ff.h"
#include "utility.h"
#include "memory.h"
/* #include "preprocess.h"  */
#include "output.h"

float *a_distance;
float **h2_from_init;


void make_minimal_state(State *S, int effect) {

  int i;
  
  S->num_F = 0;

  for(i = 0; i < gnum_ft_conn; i++) {
    if (! edeletes(effect, i)) {
      add_state_fact(S, i);
    }
    else {
      printf("\tnot including fact ");
      print_ft_name(i);
      printf(" in minimal state for action ");
      print_op_name(gef_conn[effect].op);
      printf("\n");
    }
  }
}

Bool edeletes(int effect, int fact) {

  int i;
  
  if(effect_deletes_fact(effect, fact)) {
    return TRUE;
  }
  
  for(i = 0; i < gef_conn[effect].num_A; i++) {
    if(h2_from_init[fact][gef_conn[effect].A[i]] == INFINITY) {
      return TRUE;
    }
  }

  for(i = 0; i < gef_conn[effect].num_PC; i++) {
    if(h2_from_init[fact][gef_conn[effect].PC[i]] == INFINITY) {
      if(! effect_adds_fact(effect, fact)) {
	return TRUE;
      }
    }
  }

  return FALSE;
}

float get_goal_distance(int effect) {
  return a_distance[effect];
}
