#ifndef _LIST_SET_H_
#define _LIST_SET_H_

#include <string.h>

#include "ff.h"

typedef struct _node {
  int val;
  int count;
  struct _node *next;
} node, *node_pointer;

typedef struct _list_multiset {
  int n_distinct_elems;
  node_pointer first;
} list_multiset, *list_multiset_pointer;

#define MULTISET_SIZE sizeof(multiset)
#define MULTISET_NODE_SIZE sizeof(node)

typedef list_multiset multiset;
typedef list_multiset_pointer multiset_pointer;

void set_empty(multiset_pointer);
void init_multiset(multiset_pointer);
void copy_multiset(multiset_pointer, multiset_pointer);
void multiset_union(multiset_pointer, multiset_pointer);
void multiset_intersection(multiset_pointer, multiset_pointer);
void increase_count(multiset_pointer, int);
/* increase count to 1 iff previous count 0 */
void add_elem(multiset_pointer, int);
void decrease_count(multiset_pointer, int );
int get_count(multiset_pointer, int);
int num_distinct_elems(multiset_pointer);
void print_set(multiset_pointer);

void init_iterator(multiset_pointer set, void **track);
int get_val(multiset_pointer set, void **current, int *count);

Bool remove_one_and_return(multiset_pointer set, int*);

#endif 
